<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>The ESP-AT MQTT library project: AT_Class Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">The ESP-AT MQTT library project
   </div>
   <div id="projectbrief">A simple wrapper to the MQTT functionality found in the ESP-AT interpreter</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classAT__Class-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">AT_Class Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>EspAT MQTT <a class="el" href="classAT__Class.html" title="EspAT MQTT AT_Class definition.">AT_Class</a> definition.  
 <a href="classAT__Class.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="AT_8h_source.html">AT.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:adc0b586b4dc8843104625b18382cfd32"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAT__Class.html#adc0b586b4dc8843104625b18382cfd32">AT_Class</a> (HardwareSerial *=&amp;ESP_SERIAL_PORT)</td></tr>
<tr class="memdesc:adc0b586b4dc8843104625b18382cfd32"><td class="mdescLeft">&#160;</td><td class="mdescRight">The class constructor is used to set the serial port to be used to communicate with the ESP-AT device.  <a href="classAT__Class.html#adc0b586b4dc8843104625b18382cfd32">More...</a><br /></td></tr>
<tr class="separator:adc0b586b4dc8843104625b18382cfd32"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a389087939b169b92aad704b89cfcaa69"><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAT__Class.html#a389087939b169b92aad704b89cfcaa69">readLine</a> ()</td></tr>
<tr class="memdesc:a389087939b169b92aad704b89cfcaa69"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read exactly one line from the serial port.  <a href="classAT__Class.html#a389087939b169b92aad704b89cfcaa69">More...</a><br /></td></tr>
<tr class="separator:a389087939b169b92aad704b89cfcaa69"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a408c1ed423d049988df1f0badbb89ebb"><td class="memItemLeft" align="right" valign="top"><a class="el" href="AT_8h.html#a0c488f966048be07ee0f11f6969c3524">at_status_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAT__Class.html#a408c1ed423d049988df1f0badbb89ebb">waitReply</a> (const char *asynch, uint32_t timeout)</td></tr>
<tr class="memdesc:a408c1ed423d049988df1f0badbb89ebb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read all lines until the end of the AT command sequence All lines are stored in buff[] separated with a | character so you can use strtok later on.  <a href="classAT__Class.html#a408c1ed423d049988df1f0badbb89ebb">More...</a><br /></td></tr>
<tr class="separator:a408c1ed423d049988df1f0badbb89ebb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a865aafe93ba8a75f82d084ea3885dc51"><td class="memItemLeft" align="right" valign="top"><a class="el" href="AT_8h.html#a0c488f966048be07ee0f11f6969c3524">at_status_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAT__Class.html#a865aafe93ba8a75f82d084ea3885dc51">sendCommand</a> (const char *cmd, const char *param, char **result, const char *asynch=NULL, uint32_t timeout=2000)</td></tr>
<tr class="memdesc:a865aafe93ba8a75f82d084ea3885dc51"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function sends the specified AT command and parameters to the ESP-AT device on the serial line.  <a href="classAT__Class.html#a865aafe93ba8a75f82d084ea3885dc51">More...</a><br /></td></tr>
<tr class="separator:a865aafe93ba8a75f82d084ea3885dc51"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a54f448639cbcd8bbcae4a18d0c6ba740"><td class="memItemLeft" align="right" valign="top"><a class="el" href="AT_8h.html#a0c488f966048be07ee0f11f6969c3524">at_status_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAT__Class.html#a54f448639cbcd8bbcae4a18d0c6ba740">waitPrompt</a> (uint32_t timeout)</td></tr>
<tr class="memdesc:a54f448639cbcd8bbcae4a18d0c6ba740"><td class="mdescLeft">&#160;</td><td class="mdescRight">Waits for a prompt of the character '&gt;' to arrive on the serial port.  <a href="classAT__Class.html#a54f448639cbcd8bbcae4a18d0c6ba740">More...</a><br /></td></tr>
<tr class="separator:a54f448639cbcd8bbcae4a18d0c6ba740"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6f727c41336bcfe3f6e6648a23e707c3"><td class="memItemLeft" align="right" valign="top"><a class="el" href="AT_8h.html#a0c488f966048be07ee0f11f6969c3524">at_status_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAT__Class.html#a6f727c41336bcfe3f6e6648a23e707c3">waitString</a> (const char *str, uint32_t timeout)</td></tr>
<tr class="memdesc:a6f727c41336bcfe3f6e6648a23e707c3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Wait for a specific string to arrive on the serial port.  <a href="classAT__Class.html#a6f727c41336bcfe3f6e6648a23e707c3">More...</a><br /></td></tr>
<tr class="separator:a6f727c41336bcfe3f6e6648a23e707c3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a41bef8b8a58592d0c71901926cb1666a"><td class="memItemLeft" align="right" valign="top"><a class="el" href="AT_8h.html#a0c488f966048be07ee0f11f6969c3524">at_status_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAT__Class.html#a41bef8b8a58592d0c71901926cb1666a">sendString</a> (const char *str, size_t len)</td></tr>
<tr class="memdesc:a41bef8b8a58592d0c71901926cb1666a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Send a generic string on the serial port.  <a href="classAT__Class.html#a41bef8b8a58592d0c71901926cb1666a">More...</a><br /></td></tr>
<tr class="separator:a41bef8b8a58592d0c71901926cb1666a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5250972655a0b60ae8b1433af29030c2"><td class="memItemLeft" align="right" valign="top"><a class="el" href="AT_8h.html#a0c488f966048be07ee0f11f6969c3524">at_status_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAT__Class.html#a5250972655a0b60ae8b1433af29030c2">sendString</a> (char *str, size_t len)</td></tr>
<tr class="memdesc:a5250972655a0b60ae8b1433af29030c2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Send a generic string on the serial port.  <a href="classAT__Class.html#a5250972655a0b60ae8b1433af29030c2">More...</a><br /></td></tr>
<tr class="separator:a5250972655a0b60ae8b1433af29030c2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad73cf86818fc899e76c2aa6883174c2b"><td class="memItemLeft" align="right" valign="top"><a class="el" href="AT_8h.html#a0c488f966048be07ee0f11f6969c3524">at_status_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAT__Class.html#ad73cf86818fc899e76c2aa6883174c2b">sendString</a> (const char *str)</td></tr>
<tr class="memdesc:ad73cf86818fc899e76c2aa6883174c2b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Send a generic string on the serial port.  <a href="classAT__Class.html#ad73cf86818fc899e76c2aa6883174c2b">More...</a><br /></td></tr>
<tr class="separator:ad73cf86818fc899e76c2aa6883174c2b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab5e6819d3dc047498198c681eb02d90d"><td class="memItemLeft" align="right" valign="top">char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAT__Class.html#ab5e6819d3dc047498198c681eb02d90d">read</a> ()</td></tr>
<tr class="memdesc:ab5e6819d3dc047498198c681eb02d90d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reads a byte from the serial port.  <a href="classAT__Class.html#ab5e6819d3dc047498198c681eb02d90d">More...</a><br /></td></tr>
<tr class="separator:ab5e6819d3dc047498198c681eb02d90d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acf3c1e982cd25c20cf11e2920e101b31"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAT__Class.html#acf3c1e982cd25c20cf11e2920e101b31">available</a> ()</td></tr>
<tr class="memdesc:acf3c1e982cd25c20cf11e2920e101b31"><td class="mdescLeft">&#160;</td><td class="mdescRight">Checks to see if there are any data available on the serial port.  <a href="classAT__Class.html#acf3c1e982cd25c20cf11e2920e101b31">More...</a><br /></td></tr>
<tr class="separator:acf3c1e982cd25c20cf11e2920e101b31"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aae45145ffe1c153d10b3feeba141f496"><td class="memItemLeft" align="right" valign="top">char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAT__Class.html#aae45145ffe1c153d10b3feeba141f496">getBuff</a> ()</td></tr>
<tr class="memdesc:aae45145ffe1c153d10b3feeba141f496"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a pointer to the internal receive buffer.  <a href="classAT__Class.html#aae45145ffe1c153d10b3feeba141f496">More...</a><br /></td></tr>
<tr class="separator:aae45145ffe1c153d10b3feeba141f496"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:ac5b1dcc26b1efb34dc6caa032398ad16"><td class="memItemLeft" align="right" valign="top"><a id="ac5b1dcc26b1efb34dc6caa032398ad16"></a>
HardwareSerial *&#160;</td><td class="memItemRight" valign="bottom"><b>_serial</b></td></tr>
<tr class="separator:ac5b1dcc26b1efb34dc6caa032398ad16"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac5aeb70c1e9254c9928328d239a58825"><td class="memItemLeft" align="right" valign="top"><a id="ac5aeb70c1e9254c9928328d239a58825"></a>
char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAT__Class.html#ac5aeb70c1e9254c9928328d239a58825">buff</a> [1024]</td></tr>
<tr class="memdesc:ac5aeb70c1e9254c9928328d239a58825"><td class="mdescLeft">&#160;</td><td class="mdescRight">Serial input buffer. <br /></td></tr>
<tr class="separator:ac5aeb70c1e9254c9928328d239a58825"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a55115f87056e336f9aa640b986b651c2"><td class="memItemLeft" align="right" valign="top"><a id="a55115f87056e336f9aa640b986b651c2"></a>
char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAT__Class.html#a55115f87056e336f9aa640b986b651c2">cmdBuff</a> [256]</td></tr>
<tr class="memdesc:a55115f87056e336f9aa640b986b651c2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Command buffer for stuff sent to the ESP-AT device. <br /></td></tr>
<tr class="separator:a55115f87056e336f9aa640b986b651c2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0c1ad8f178ca5018ce94a7b4bdb1a02b"><td class="memItemLeft" align="right" valign="top"><a id="a0c1ad8f178ca5018ce94a7b4bdb1a02b"></a>
char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAT__Class.html#a0c1ad8f178ca5018ce94a7b4bdb1a02b">resBuff</a> [128]</td></tr>
<tr class="memdesc:a0c1ad8f178ca5018ce94a7b4bdb1a02b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Result buffer for parameter data returned from the ESP-AT device. <br /></td></tr>
<tr class="separator:a0c1ad8f178ca5018ce94a7b4bdb1a02b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4fb40d576da2508322ada4cd9d525c87"><td class="memItemLeft" align="right" valign="top"><a id="a4fb40d576da2508322ada4cd9d525c87"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAT__Class.html#a4fb40d576da2508322ada4cd9d525c87">wx</a></td></tr>
<tr class="memdesc:a4fb40d576da2508322ada4cd9d525c87"><td class="mdescLeft">&#160;</td><td class="mdescRight">Write pointer to the input buffer while processing an ESP-AT response. <br /></td></tr>
<tr class="separator:a4fb40d576da2508322ada4cd9d525c87"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af02fefaf594962a878cffffc78b703e4"><td class="memItemLeft" align="right" valign="top"><a id="af02fefaf594962a878cffffc78b703e4"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAT__Class.html#af02fefaf594962a878cffffc78b703e4">line</a></td></tr>
<tr class="memdesc:af02fefaf594962a878cffffc78b703e4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Keeps track of how many lines have been received during the processing of an ESP-AT reply. <br /></td></tr>
<tr class="separator:af02fefaf594962a878cffffc78b703e4"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>EspAT MQTT <a class="el" href="classAT__Class.html" title="EspAT MQTT AT_Class definition.">AT_Class</a> definition. </p>
<p>This class provides an AT interface layer that can be used by higher level software to easily send and receive data to and from an ESP-AT module. The module takes care of sending the desired command, waiting for a response as well as storing and parsing the returned data.</p>
<p>A few support functions are also included for implementations that require more control over the data sent and received. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="adc0b586b4dc8843104625b18382cfd32"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adc0b586b4dc8843104625b18382cfd32">&#9670;&nbsp;</a></span>AT_Class()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">AT_Class::AT_Class </td>
          <td>(</td>
          <td class="paramtype">HardwareSerial *&#160;</td>
          <td class="paramname"><em>serial</em> = <code>&amp;ESP_SERIAL_PORT</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>The class constructor is used to set the serial port to be used to communicate with the ESP-AT device. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">-</td><td>serial The serial port that the ESP device is connected to. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="acf3c1e982cd25c20cf11e2920e101b31"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acf3c1e982cd25c20cf11e2920e101b31">&#9670;&nbsp;</a></span>available()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int AT_Class::available </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Checks to see if there are any data available on the serial port. </p>
<dl class="section return"><dt>Returns</dt><dd>- The number of bytes found available in the serial read buffer. </dd></dl>

</div>
</div>
<a id="aae45145ffe1c153d10b3feeba141f496"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aae45145ffe1c153d10b3feeba141f496">&#9670;&nbsp;</a></span>getBuff()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">char * AT_Class::getBuff </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns a pointer to the internal receive buffer. </p>
<p>Can be used by the caller to directly access the recevied data string from the ESP-AT device.</p>
<dl class="section return"><dt>Returns</dt><dd>- A pointer to the internal data receive buffer. </dd></dl>

</div>
</div>
<a id="ab5e6819d3dc047498198c681eb02d90d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab5e6819d3dc047498198c681eb02d90d">&#9670;&nbsp;</a></span>read()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">char AT_Class::read </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Reads a byte from the serial port. </p>
<p>The function ensures that a valid byte has been received from the ESP-AT device before returning the data.</p>
<dl class="section return"><dt>Returns</dt><dd>- The data byte received from the ESP-AT device. </dd></dl>

</div>
</div>
<a id="a389087939b169b92aad704b89cfcaa69"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a389087939b169b92aad704b89cfcaa69">&#9670;&nbsp;</a></span>readLine()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t AT_Class::readLine </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Read exactly one line from the serial port. </p>
<p>Each line that is read is appended to the internal buffer to create a internal processable response. CR and LF's are removed and replaced with a '|' character to separate the lines in the buffer. This can then later be process using strtok or a similar function.</p>
<dl class="section return"><dt>Returns</dt><dd>The number of characters read from the serial port. </dd></dl>

</div>
</div>
<a id="a865aafe93ba8a75f82d084ea3885dc51"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a865aafe93ba8a75f82d084ea3885dc51">&#9670;&nbsp;</a></span>sendCommand()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="AT_8h.html#a0c488f966048be07ee0f11f6969c3524">at_status_t</a> AT_Class::sendCommand </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>cmd</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>param</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char **&#160;</td>
          <td class="paramname"><em>result</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>asynch</em> = <code>NULL</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>timeout</em> = <code>2000</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function sends the specified AT command and parameters to the ESP-AT device on the serial line. </p>
<p>The function adds the "AT" part of the command so this must not be a part of the command string when calling the function.</p>
<p>It then waits for the AT response to come back from the ESP-AT device and returns with the result of the operation. It also detects if the ESP-AT device does not return a reply within the specified time limit.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">-</td><td>cmd The AT command that should be executed (without the AT part). No &lt;CR&gt; or &lt;LF&gt; characters must be present in this string. Example: "+GMR" (Returns the firmware version) </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">-</td><td>param This is the parameter part of the AT command. It should hold all the necessary and relevant parameters of the AT command. No &lt;CR&gt; or &lt;LF&gt; characters must be present in this string. Example "=0,1,"alpn.ilabs.se"" </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">-</td><td>result When an AT command returns a parameter as a result of the operation the AT handler takes care of this and can be returned to the caller. By supplying a non NULL ptrptr the caller can get access to this parameter. If this parameter is NULL the result is simply discarded. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">-</td><td>asynch Some AT commands return their result completely asynchronous to the OK or ERROR reply and also with a completely different URC tag. For instance the command "AT+MQTTCONN=" can return the response "+MQTTCONNECTED:" both before and after the OK response. In this case by setting this parameter to "+MQTTCONNECTED:" the function will look for this data both when waiting for the OK response as well as after the OK response has been received or a timeout has occured. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">-</td><td>timeout The amount of time, in milliseconds, that the function will wait for a reply from the ESP-AT device. This value is also used when waiting for an asynchronous response.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>- The status of the operation, See <a class="el" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701" title="Status codes that the AT handler can return.">status_code_e</a> for more information. </dd></dl>

</div>
</div>
<a id="a5250972655a0b60ae8b1433af29030c2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5250972655a0b60ae8b1433af29030c2">&#9670;&nbsp;</a></span>sendString() <span class="overload">[1/3]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="AT_8h.html#a0c488f966048be07ee0f11f6969c3524">at_status_t</a> AT_Class::sendString </td>
          <td>(</td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>str</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>len</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Send a generic string on the serial port. </p>
<p>Can be used to send anything to the connected ESP-AT device.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">-</td><td>str (char *) The string/data that we want to send. Does not need to be '\0' terminated. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">-</td><td>len The length of the string/data that we want to send.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>- The status of the operation, See <a class="el" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701" title="Status codes that the AT handler can return.">status_code_e</a> for more information. </dd></dl>

</div>
</div>
<a id="ad73cf86818fc899e76c2aa6883174c2b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad73cf86818fc899e76c2aa6883174c2b">&#9670;&nbsp;</a></span>sendString() <span class="overload">[2/3]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="AT_8h.html#a0c488f966048be07ee0f11f6969c3524">at_status_t</a> AT_Class::sendString </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>str</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Send a generic string on the serial port. </p>
<p>Can be used to send anything to the connected ESP-AT device.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">-</td><td>str (const char *) The string/data that we want to send. Must be '\0' terminated.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>- The status of the operation, See <a class="el" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701" title="Status codes that the AT handler can return.">status_code_e</a> for more information. </dd></dl>

</div>
</div>
<a id="a41bef8b8a58592d0c71901926cb1666a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a41bef8b8a58592d0c71901926cb1666a">&#9670;&nbsp;</a></span>sendString() <span class="overload">[3/3]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="AT_8h.html#a0c488f966048be07ee0f11f6969c3524">at_status_t</a> AT_Class::sendString </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>str</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>len</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Send a generic string on the serial port. </p>
<p>Can be used to send anything to the connected ESP-AT device.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">-</td><td>str (const char *) The string/data that we want to send. Does not need to be '\0' terminated. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">-</td><td>len The length of the string/data that we want to send.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>- The status of the operation, See <a class="el" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701" title="Status codes that the AT handler can return.">status_code_e</a> for more information. </dd></dl>

</div>
</div>
<a id="a54f448639cbcd8bbcae4a18d0c6ba740"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a54f448639cbcd8bbcae4a18d0c6ba740">&#9670;&nbsp;</a></span>waitPrompt()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="AT_8h.html#a0c488f966048be07ee0f11f6969c3524">at_status_t</a> AT_Class::waitPrompt </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>timeout</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Waits for a prompt of the character '&gt;' to arrive on the serial port. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">-</td><td>timeout The time allowed, in millisecond, for the prompt to arrive</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>- The status of the operation, See <a class="el" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701" title="Status codes that the AT handler can return.">status_code_e</a> for more information. </dd></dl>

</div>
</div>
<a id="a408c1ed423d049988df1f0badbb89ebb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a408c1ed423d049988df1f0badbb89ebb">&#9670;&nbsp;</a></span>waitReply()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="AT_8h.html#a0c488f966048be07ee0f11f6969c3524">at_status_t</a> AT_Class::waitReply </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>asynch</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>timeout</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Read all lines until the end of the AT command sequence All lines are stored in buff[] separated with a | character so you can use strtok later on. </p>
<p>The asynch parameter can be used to ensure that a message that is asynchronous to the OK or ERROR response is always received within the given timeout value. If not, a ESP_AT_SUB_CMD_TIMEOUT error will be reported back to the caller. Important note: the asynchronous message could possibly still come in after the timeout has elapsed in case of unstable or extremely slow networks. In this case it is important to make sure it is taken care of in the mqtt process() function.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">-</td><td>asynch Any asynchronous data that is required. Can be NULL if no asynchronous data is expected. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">-</td><td>timeout The maximum amount of time (in milliseconds) that is allowed before a response is expected. If data has not arrived within the alloted time the function will return with a timeout error message.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>- The status of the operation, See <a class="el" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701" title="Status codes that the AT handler can return.">status_code_e</a> for more information. </dd></dl>

</div>
</div>
<a id="a6f727c41336bcfe3f6e6648a23e707c3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6f727c41336bcfe3f6e6648a23e707c3">&#9670;&nbsp;</a></span>waitString()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="AT_8h.html#a0c488f966048be07ee0f11f6969c3524">at_status_t</a> AT_Class::waitString </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>str</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>timeout</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Wait for a specific string to arrive on the serial port. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">-</td><td>str Holds the string that we are looking for. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">-</td><td>timeout The maximum time allowed to wait for the string to arrive.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>- The status of the operation, See <a class="el" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701" title="Status codes that the AT handler can return.">status_code_e</a> for more information. </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>src/<a class="el" href="AT_8h_source.html">AT.h</a></li>
<li>src/AT.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
